// CqWwInfoButton.cpp : implementation file
//

//********************************************************************//
//     DXCC -                 //
//                     //
//********************************************************************//
#include "stdafx.h"
#include "stats.h"
#include "CqWwInfoButton.h"

#include "resource.h"

#include "memdc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


extern CString gblCall;
extern CString gblCountry;
extern CStringArray m_Bands;
extern CStringArray m_CallInfo[6];
extern CStringArray m_DxccInfo[6];
extern int gblCurrentBandIdx;

/////////////////////////////////////////////////////////////////////////////
// CCqWwInfoButton

CCqWwInfoButton::CCqWwInfoButton()
{
}

CCqWwInfoButton::~CCqWwInfoButton()
{
}


BEGIN_MESSAGE_MAP(CCqWwInfoButton, CButton)
	//{{AFX_MSG_MAP(CCqWwInfoButton)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCqWwInfoButton message handlers

void CCqWwInfoButton::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct) 
{
	CDC dc;
	dc.Attach(lpDrawItemStruct->hDC);
	{
		CMemDC mdc(&dc,0,0);

		if (gblCall.IsEmpty())
		{
			long bgcolor = RGB(255,250,198);
			mdc.FillSolidRect(&lpDrawItemStruct->rcItem,bgcolor);
			if (gblCurrentBandIdx>=0)
			{
				mdc.SetBkMode(TRANSPARENT);
				int XPos = 5;
				int	YPos = 5;
//				mdc.TextOut(XPos, YPos, "DXCC worked on " + m_Bands[gblCurrentBandIdx]);
				YPos+=10;

				int size = m_DxccInfo[gblCurrentBandIdx].GetSize();
				
				{
				// sort
					for (int i = 0; i<size-1;i++)
					{
						for (int j=i+1; j<size;j++)
						{
							if (m_DxccInfo[gblCurrentBandIdx].ElementAt(j) < m_DxccInfo[gblCurrentBandIdx].ElementAt(i)) // swap
							{
								CString tmp =m_DxccInfo[gblCurrentBandIdx].ElementAt(j);
								m_DxccInfo[gblCurrentBandIdx].ElementAt(j) = m_DxccInfo[gblCurrentBandIdx].ElementAt(i);
								m_DxccInfo[gblCurrentBandIdx].ElementAt(i) = tmp;
							}
						}		
					}
				}

				for (int i = 0; i<size;i++)
				{
					CString s = m_DxccInfo[gblCurrentBandIdx].ElementAt(i);
					mdc.TextOut(XPos, YPos, s);
					XPos+=40;
					if (XPos>lpDrawItemStruct->rcItem.right-40)
					{
						YPos+=15;
						XPos=5;
					}
				}
			}
		}
		else
		{
			long bgcolor = RGB(255,255,198);
			mdc.FillSolidRect(&lpDrawItemStruct->rcItem,bgcolor);

			int iYstep = lpDrawItemStruct->rcItem.bottom/7;

			if (gblCurrentBandIdx>=0)
			{
				long selcolor  = RGB(198,255,255);
				CRect r;
				r.left =0; r.right = lpDrawItemStruct->rcItem.right;// 250; limit to 250 if needed space
				r.top = iYstep*(gblCurrentBandIdx+1);
				r.bottom = iYstep*(gblCurrentBandIdx+2);
				mdc.FillSolidRect(&r,selcolor);
			}

			mdc.SetBkMode(TRANSPARENT);


			for (int i = 0; i<=6; i++)
			{
				if (i==0)
				{
//					mdc.TextOut(20, i*iYstep, "Band");
//					mdc.TextOut(100, i*iYstep, gblCountry);
					mdc.TextOut(180, i*iYstep, gblCall);
					mdc.TextOut(100, 18,"BPSK31");
					mdc.TextOut(180, 18,"BPSK63");
					mdc.TextOut(260, 18,"BPSK125");

				}
				else
				{
					mdc.TextOut(20, i*iYstep, m_CallInfo[i-1].ElementAt(0));
					mdc.TextOut(100, i*iYstep, m_CallInfo[i-1].ElementAt(1));
					mdc.TextOut(180, i*iYstep, m_CallInfo[i-1].ElementAt(2));
					mdc.TextOut(260, i*iYstep, m_CallInfo[i-1].ElementAt(3));
				}
			}
		}		
	}
	dc.Detach();
}

