// DXCC.cpp : implementation file
//

//********************************************************************//
//              DXCC                                  //
//********************************************************************//
#include "stdafx.h"
//#include "cabrillo.h"
#include "DXCC.h"
#include "oblast.h"
#include "baud.h"
#include "mixw2.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//    

extern IMixW2 mixw;
extern CLSID clsid;
extern IUnknown *pUnk;
extern  IDispatch *pDisp;
extern HRESULT hr;
// 

extern oblast *m_pObl;
extern baud *m_pbaud;

//   

extern RECT rRect;
extern  int x;
extern  int y;

//    .

extern void WritePrivateProfileInt(CString Section, CString Key, int iValue, CString IniFilename);
extern	CString IniSection;// = "Settings";
extern    CString IniFilename;// = "Plugins\\EPCRU.ini";
#define MAX_BUF 10000
extern	char buf[MAX_BUF+1];


// 

extern int gblCurrentBandIdx;
extern CStringArray m_Bands;
extern CString gblCall;
extern CStringArray m_DxccInfo[6];
extern CString Year_Test;

/////////////////////////////////////////////////////////////////////////////
// DXCC dialog


DXCC::~DXCC()
{


}

DXCC::DXCC(CWnd* pParent /*=NULL*/)
	: CDialog(DXCC::IDD, pParent)
{
	//{{AFX_DATA_INIT(DXCC)
	//}}AFX_DATA_INIT
//		m_bDoExit = FALSE;
}


void DXCC::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(DXCC)
		DDX_Control(pDX, IDC_BUTTON_INFO, m_bnInfo);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(DXCC, CDialog)
	//{{AFX_MSG_MAP(DXCC)
	ON_WM_TIMER()
	ON_WM_SETCURSOR()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
/*******************************************************************************************/

/////////////////////////////////////////////////////////////////////////////
// DXCC message handlers


//********************************************************************//
//                DXCC                //
//********************************************************************//
BOOL DXCC::OnInitDialog() 
{
	CDialog::OnInitDialog();
    GetPrivateProfileString(IniSection, "dxcc_x", "", buf, MAX_BUF, IniFilename);
	x = atoi(buf);
	GetPrivateProfileString(IniSection, "dxcc_y", "", buf, MAX_BUF, IniFilename);
	y = atoi(buf);
  if(x ==0) x=10;
  if(y==0) y=400;
		SetWindowPos(NULL,x, y, 0, 100, SWP_NOZORDER|SWP_NOSIZE );
//		SetWindowPos ( &wndNoTopMost, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSIZE );
	


//			SetWindowPos(&wndTopMost,0, 0, 0, 0,
//			SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE);

	// TODO: Add extra initialization here
	   	CWinThread* p = AfxGetThread();
			HICON newIcon= AfxGetApp()->LoadIcon(IDI_ICON1);
			(this)->SetIcon(newIcon,TRUE);

				SetTimer(1442,300,0);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}



//********************************************************************//
//      DXCC    DXCC        //
//********************************************************************//
void DXCC::OnTimer(UINT nIDEvent) 
{

	CString sBandRx;
		double freq;
	int m;
	int k = -1;
	int band =0;
	int qsos_band =0;
	int nr_dxcc;
	char buf[10];
	// TODO: Add your message handler code here and/or call default

      KillTimer(1442);

//  MixW
  ((*(COleDispatchDriver*)(&mixw))).m_lpDispatch = pDisp;//Init object



  	freq = mixw.GetFqA();

  

	m = freq/1000000;

        if(m == 1) 
		{
			k=0;
			sBandRx = "160m";

		}
		if(m == 3) 
		{
			k=1;
			sBandRx = "80m";
			
		}

		if(m == 7) 
		{
			k=2;
			sBandRx = "40m";
			
		}
		if(m == 14)
		{
			k=3;
			sBandRx = "20m";
			
		}
		if(m == 21)
		{
			k=4;
			sBandRx = "15m";
			
		}

		if(m == 28)
		{
			k=5;
			sBandRx = "10m";
			
		}





	gblCurrentBandIdx = k; //    

//      

    if(gblCurrentBandIdx == -1 ) nr_dxcc = 0;
	else
		nr_dxcc = m_DxccInfo[gblCurrentBandIdx].GetSize();
	    itoa(nr_dxcc,buf,10);
	sBandRx = "RUS-WW-PSK "+ Year_Test + "  DXCC worked on " + sBandRx + " " + buf + " of 338";
	if (gblCall.IsEmpty()) SetWindowText(sBandRx);




//   
		


		CWnd* pWnd = GetDlgItem(IDC_BUTTON_INFO);
     	if (pWnd)
	         	pWnd->Invalidate(0);

CDialog::OnTimer(nIDEvent);

}

//     

BOOL DXCC::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
	// TODO: Add your message handler code here and/or call default
	char buf[10];

	GetWindowRect(&rRect);
    int x1 = rRect.left;
	int y1 = rRect.top;
	
	if(x1 != x) 
	{
		
		x = x1;
	    itoa(x,buf,10);
		WritePrivateProfileString(IniSection, "dxcc_x", buf,  IniFilename);

	}
	if(y1 != y) 
	{
		y = y1;
		itoa(y,buf,10);
		WritePrivateProfileString(IniSection, "dxcc_y", buf,  IniFilename);

	}

	return CDialog::OnSetCursor(pWnd, nHitTest, message);
}

//********************************************************************//
//                DXCC                           //
//********************************************************************//
void DXCC::OnSize(UINT nType, int cx, int cy) 
{

	CDialog::OnSize(nType, cx, cy);
	CWnd* ct = GetDlgItem(IDC_BUTTON_INFO);
	CRect cr;
	GetClientRect(cr);
	if(ct) ct->MoveWindow(cr.left+5,cr.top+5,cr.right-10,cr.bottom-10);
	
	 

	
	// TODO: Add your message handler code here
	
}
